<?php

class myChangeNicknameValidator extends sfValidator
{
	public function initialize($context, $parameters = null)
	{
		// initialize parent
		parent::initialize($context);

		// set defaults
		$this->setParameter('change_error', 'Invalid input');

		$this->getParameterHolder()->add($parameters);

		return true;
	}

	public function execute(&$value, &$error)
	{
		$current_nickname = $this->getContext()->getUser()->getNickname();

		$new_nickname = $value;

		// changed the nickname?
		if($new_nickname == $current_nickname)
			return true;

		$c = new Criteria();
		$c->add(UserPeer::NICKNAME, $new_nickname);
		$user = UserPeer::doSelectOne($c);

		// nickname exists?
		if($user)
		{
			$error = $this->getParameter('change_error');
			return false;
		}

		return true;
	}
}

?>
