<?php

/**
 * Subclass for performing query and update operations on the 'domain_permission' table.
 *
 * 
 *
 * @package lib.model
 */ 
class DomainPermissionPeer extends BaseDomainPermissionPeer
{
	// inject domain permissions criteria
	public static function addDomainPermissionCriteria(Criteria $criteria, $domain_id = DomainPeer::DOMAIN_ID)
	{
		if(sfContext::getInstance()->getUser()->hasCredential("superadmin"))
			return;

		// set domain permissions
		$criteria->addJoin(DomainPermissionPeer::DOMAIN_ID, $domain_id);
		$criteria->add(DomainPermissionPeer::USER_ID, sfContext::getInstance()->getUser()->getId());
	}
}
