<?php



class DomainMapBuilder {

	
	const CLASS_NAME = 'lib.model.map.DomainMapBuilder';

	
	private $dbMap;

	
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap('propel');

		$tMap = $this->dbMap->addTable('domain');
		$tMap->setPhpName('Domain');

		$tMap->setUseIdGenerator(true);

		$tMap->addPrimaryKey('ID', 'Id', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addColumn('NAME', 'Name', 'string', CreoleTypes::VARCHAR, false, 255);

		$tMap->addForeignKey('CREATOR_ID', 'CreatorId', 'int', CreoleTypes::INTEGER, 'user', 'ID', false, null);

		$tMap->addColumn('MAILBOX_PREFIX', 'MailboxPrefix', 'string', CreoleTypes::VARCHAR, false, 255);

		$tMap->addColumn('MAX_MAILBOX_COUNT', 'MaxMailboxCount', 'int', CreoleTypes::INTEGER, false, null);

		$tMap->addColumn('QUOTA', 'Quota', 'int', CreoleTypes::INTEGER, false, null);

		$tMap->addColumn('DEFAULT_MAILBOX_QUOTA', 'DefaultMailboxQuota', 'int', CreoleTypes::INTEGER, false, null);

	} 
} 